package proiect;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.NoSuchFileException;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;

public class Store {
	private List<Animal> animals;

	public Store() {
		animals = new ArrayList<Animal>();
	}

	public void add(Animal animal) {
		animals.add(animal);
	}

	public void remove(int pos) {
		animals.remove(pos);
	}

	public List<Animal> getAnimals() {
		return animals;
	}

	public void update(int pos, Animal animal) {
		animals.set(pos, animal);
	}

	public Animal get(int pos) {
		return animals.get(pos);
	}

	public void save() {
		ObjectMapper mapper = new ObjectMapper();

		File file = new File("src/main/resources/animals.json");

		try {
			mapper.writeValue(file, animals);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void load() {
		ObjectMapper mapper = new ObjectMapper();

		try {
			String json = new String(Files.readAllBytes(Paths.get("src/main/resources/animals.json")));
			animals = mapper.readValue(json, new TypeReference<List<Animal>>() {
			});
		} catch (NoSuchFileException e) {
			System.out.println("No database found. Starting with an empty one");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
